// POVRAY ||| COURS N3 08/11/2006

// BIBLIOTHEQUE
#include "lib_1.inc"
#include "lib_2.inc"

#macro murs()
	object
	{	difference
		{	box { <-3.00,-3.00,-3.00>, < 3.00, 3.00, 3.00> }
			box { <-2.80,-3.01,-2.80>, < 2.80, 3.01, 2.80> }
			box { <-3.01,-3.01,-3.01>, <-0.90, 0.00, 3.01> }
			box { <-3.01,-0.01,-2.80>, <-2.69, 1.20, 2.80> }
			box { < 2.79, 0.00, 0.00>, < 3.01, 3.01,-0.90> }
		}
		texture
		{	pigment 
			{ 	marble
				color_map 
				{  [ 0.0 color rgb 0.2 ] [ 0.3 color rgbt <0.8,0.8,0.8,0.0> ] }
				scale 1/4*12/10
				rotate <0,0,90>
			}
			finish { ambient 0.3 diffuse 0.7 specular 0.0 }
		}
	}
#end

#macro doublage()
	object
	{	difference
		{	box { <-2.80,-2.10,-2.80>, < 2.80, 2.70, 2.80> }
			box { <-2.70,-3.01,-2.70>, < 2.70, 3.01, 2.70> }
			box { <-3.01,-3.01,-3.01>, <-0.90, 0.00, 3.01> }
			box { <-3.01,-0.01,-2.70>, <-2.69, 1.20, 2.70> }
			box { < 2.69, 0.00, 0.00>, < 3.01, 3.01,-0.90> }
		}
		texture
		{	pigment 
			{ 	marble
				color_map 
				{  [ 0.0 color rgb <1,0,0> ] [ 0.1 color rgb <1.0,0.9,0.8> ] }
				scale 1/4*12/10
				rotate <0,0,90>
			}
			finish { ambient 0.3 diffuse 0.7 specular 0.0 }
		}
	}
#end

#macro poutre( largeur, hauteur, longueur )
	object
	{	box { <0.00,0.00,0.00>, <largeur,hauteur,longueur> }
		texture
		{	pigment 
			{ 	marble
				color_map 
				{  [ 0.0 color rgb <0.9,0.5,0> ] [ 1.0 color rgb <0.9,0.8,0.0> ] }
				scale 1/32
				rotate <0,0,90>
			}
			finish { ambient 0.3 diffuse 0.7 specular 0.0 }
		}
	}
#end

#macro panneau( longueur, largeur, epaisseur )
	object
	{	box { <0.00,0.00,0.00>, <longueur,epaisseur,largeur> }
		texture
		{	pigment 
			{ 	marble
				color_map 
				{  [ 0.0 color rgb <0.0,0.0,0> ] [ 0.2 color rgbt <0.5,0.5,0.2,0.7> ] }
				scale 1/8
				rotate <0,0,0>
			}
			finish { ambient 0.3 diffuse 0.7 specular 0.0 }
		}
	}
#end

#macro plancher_3()
union
{	object { poutre( 0.10,-0.30, 5.60 ) translate < 0.80, 2.70,-2.80> }
	object { panneau( 3.60, 5.40, 0.02 ) translate <-2.70, 2.70,-2.70> }
	#local i=0; #while (i<13)
		#local uu = -2.725 + 0.45*i;
		object { poutre( 0.05,-0.15, 3.60 ) translate < uu, 2.70,-2.70> rotate <0,90,0> }
	#local i=i+1; #end
}
#end

#macro plancher_2()
union
{	object { poutre( 0.10,-0.30, 5.60 ) translate < 0.80, 0.30,-2.80> }
	object { poutre( 0.10,-0.30, 5.60 ) translate <-2.80, 0.30,-2.80> }
	object { panneau( 3.60, 5.40, 0.02 ) translate <-2.70, 0.30,-2.70> }
	object { panneau( 1.80, 3.60, 0.02 ) translate < 0.90, 0.30,-0.90> }
	#local i=0; #while (i<13)
		#local uu = -2.725 + 0.45*i;
		#if (i<9)
			object { poutre( 0.05,-0.15, 5.40 ) translate < uu, 0.30,-2.70> rotate <0,90,0> }
		#else
			object { poutre( 0.05,-0.15, 3.60 ) translate < uu, 0.30,-2.70> rotate <0,90,0> }
		#end
	#local i=i+1; #end
}
#end

#macro plancher_1()
union
{	object { poutre( 0.10,-0.30, 5.60 ) translate < 0.80,-2.10,-2.80> }
	object { poutre( 0.10,-0.30, 5.60 ) translate <-2.80,-2.10,-2.80> }
	object { poutre( 0.10,-0.30, 5.60 ) rotate <0, 90,0> translate <-2.80,-2.10, 2.80> }
	object { poutre( 0.10,-0.30, 5.60 ) rotate <0, 90,0> translate <-2.80,-2.10,-2.70> }
	object { panneau( 5.40, 5.40, 0.02 ) translate <-2.70,-2.10,-2.70> }
	#local i=0; #while (i<13)
		#local uu = -2.725 + 0.45*i;
		object { poutre( 0.05,-0.15, 5.40 ) translate < uu,-2.10,-2.70> rotate <0,90,0> }
	#local i=i+1; #end
}
#end

// SCENE
//camera { location <-0.8,1.1,-1>*5 look_at <0,0,0> }				// PERSPECTIVE 1

camera { location < -6,-1,-4> look_at <0,0,0> }				// PERSPECTIVE 2

//camera { orthographic location <-0.8,1.2,-1>*5 look_at <0,0,0> }	// ISOMETRIE
//camera { orthographic location <0,1.2,0>*6 look_at <0,0,0> }		// PLAN
//camera { orthographic location <0,0,-1.2>*6 look_at <0,0,0> }		// ELEV LATERALE 
//camera { orthographic location <1.2,0,0>*6 look_at <0,0,0> }		// ELEV ARRIERE 
//camera { orthographic location <-1.2,0,0>*6 look_at <0,0,0> }		// ELEV AVANT
background { color rgb 2/4 }
light_source { <-1,1,-1>*6 color rgb <1,1,1> } 
light_source { <1,1,-1>*6 color rgb <1,1,1> } 
light_source { <0,1,5>*6 color rgb <1,1,1> } 
axes( 5, 0.05 )
murs()
doublage()
plancher_3()
plancher_2()
plancher_1()























